Skip to content

Commit 7ada6dd

Browse files
author
lucifer
committed
feat: 两道 dp
1 parent c5ded15 commit 7ada6dd

4 files changed

+180
-1
lines changed

README.md

+3-1
Original file line numberDiff line numberDiff line change
@@ -241,7 +241,9 @@ leetcode 题解,记录自己的 leetcode 解题之路。
241241
<summary> :point_right::point_right::point_right:点击展开题目列表:point_left::point_left::point_left:</summary>
242242

243243
- [面试题 17.09. 第 k 个数](./problems/get-kth-magic-number-lcci.md)
244-
- [面试题 17.23. 最大黑方阵](./problems/max-black-square-lcci.md)🆕
244+
- [面试题 17.23. 最大黑方阵](./problems/max-black-square-lcci.md) 🆕
245+
- [Increasing Digits](./problems/Increasing-Digits.md) 👍 🆕
246+
- [Longest Contiguously Strictly Increasing Sublist After Deletion](./problems/Longest-Contiguously-Strictly-Increasing-Sublist-After-Deletion.md) 👍 🆕
245247

246248
- [0002. 两数相加](./problems/2.add-two-numbers.md) 👍
247249
- [0003. 无重复字符的最长子串](./problems/3.longest-substring-without-repeating-characters.md)

SUMMARY.md

+2
Original file line numberDiff line numberDiff line change
@@ -98,6 +98,8 @@
9898

9999
- [面试题 17.09. 第 k 个数](./problems/get-kth-magic-number-lcci.md)
100100
- [面试题 17.23. 最大黑方阵](./problems/max-black-square-lcci.md)🆕
101+
- [Increasing Digits](./problems/Increasing-Digits.md) 👍 🆕
102+
- [Longest Contiguously Strictly Increasing Sublist After Deletion](./problems/Longest-Contiguously-Strictly-Increasing-Sublist-After-Deletion.md) 👍 🆕
101103
- [0002. 两数相加](./problems/2.add-two-numbers.md)
102104
- [0003. 无重复字符的最长子串](./problems/3.longest-substring-without-repeating-characters.md)
103105
- [0005. 最长回文子串](./problems/5.longest-palindromic-substring.md)

problems/Increasing-Digits.md

+72
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,72 @@
1+
## 题目地址(475. Increasing Digits)
2+
3+
https://binarysearch.com/problems/Increasing-Digits
4+
5+
## 题目描述
6+
7+
```
8+
Given an integer n, return the number of positive integers of length n such that the digits are strictly increasing.
9+
10+
Example 1
11+
Input
12+
n = 2
13+
Output
14+
36
15+
Explanation
16+
We have 12, 13, 14, ..., 89.
17+
18+
Example 2
19+
Input
20+
n = 1
21+
Output
22+
9
23+
```
24+
25+
## 前置知识
26+
27+
- 动态规划
28+
29+
## 思路
30+
31+
动态规划问题的关键就是:假设部分子问题已经解决了,并仅仅考虑局部,思考如何将已解决的子问题变成更大的子问题,这样就相当于向目标走进了一步。
32+
33+
我们可以定义状态 dp[i][j], i 表示数字的位数,j 表示数字的结尾数字。
34+
35+
于是转移方程就是:dp[i][j] += dp[i - 1][k],其中 k 是所有小于 j 的非负整数。最后只要返回 dp[n-1] 的和即可。
36+
37+
初始化的时候,由于题目限定了整数,因此需要初始化除了第一位的所有情况都为 1。
38+
39+
## 关键点
40+
41+
- 数位 DP
42+
43+
## 代码
44+
45+
代码支持:Python3
46+
47+
Python3 Code:
48+
49+
```py
50+
class Solution:
51+
def solve(self, n):
52+
dp = [[0] * 10 for _ in range(n)]
53+
dp[0] = [0] + [1] * 9
54+
55+
for i in range(1, n):
56+
for j in range(1, 10):
57+
for k in range(j):
58+
dp[i][j] += dp[i - 1][k]
59+
return sum(dp[-1])
60+
61+
```
62+
63+
**复杂度分析**
64+
65+
令 n 为数组长度。
66+
67+
- 时间复杂度:$O(n)$
68+
- 空间复杂度:$O(n)$
69+
70+
力扣的小伙伴可以[关注我](https://leetcode-cn.com/u/fe-lucifer/),这样就会第一时间收到我的动态啦~
71+
72+
以上就是本文的全部内容了。大家对此有何看法,欢迎给我留言,我有时间都会一一查看回答。更多算法套路可以访问我的 LeetCode 题解仓库:https://github.com/azl397985856/leetcode 。 目前已经 40K star 啦。大家也可以关注我的公众号《力扣加加》带你啃下算法这块硬骨头。
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,103 @@
1+
## 题目地址(168. Longest Contiguously Strictly Increasing Sublist After Deletion)
2+
3+
https://binarysearch.com/problems/Longest-Contiguously-Strictly-Increasing-Sublist-After-Deletion
4+
5+
## 题目描述
6+
7+
```
8+
Given a list of integers nums, return the maximum length of a contiguous strictly increasing sublist if you can remove one or zero elements from the list.
9+
10+
Constraints
11+
12+
n ≤ 100,000 where n is the length of nums
13+
Example 1
14+
Input
15+
nums = [30, 1, 2, 3, 4, 5, 8, 7, 22]
16+
Output
17+
7
18+
Explanation
19+
If you remove 8 in the list you can get [1, 2, 3, 4, 5, 7, 22] which is the longest, contiguous, strictly increasing list.
20+
```
21+
22+
## 前置知识
23+
24+
- 动态规划
25+
26+
## 思路
27+
28+
出这道题就是为了让大家明白一点**对于连续性的 DP 问题通常我们的策略都是一层循环 + 一维 DP(有时候可滚动数组优化)**。比如今天这个题。
29+
30+
动态规划问题的关键就是:假设部分子问题已经解决了,并仅仅考虑局部,思考如何将已解决的子问题变成更大的子问题,这样就相当于向目标走进了一步。
31+
32+
我们可以定义状态:
33+
34+
- dp[i][0] 表示以 nums[i] 结尾的删除 0 个数的情况下的最长严格递增子数组。
35+
- dp[i][1] 表示以 nums[i] 结尾的删除 1 个数的情况下的最长严格递增子数组。
36+
37+
> 你也可定义两个一维数组,而不是一个二维数组。比如 dp0[i] 表示以 nums[i] 结尾的删除 0 个数的情况下的最长严格递增子数组。dp1[i] 表示以 nums[i] 结尾的删除 1 个数的情况下的最长严格递增子数组
38+
39+
接下来,我们需要分情况讨论。
40+
41+
- 如果 nums[i] > nums[i-1],那么 dp[i][0] 和 dp[i][1] 都可以在前一个的基础上 + 1。也就是:
42+
43+
```py
44+
dp[i][0] = dp[i-1][0] + 1
45+
dp[i][1] = dp[i-1][1] + 1
46+
```
47+
48+
- 否则 dp[i][0] = dp[i][1] = 1
49+
50+
最终返回遍历过程中的 dp[i][0] 和 dp[i][1] 的最大值,用一个变量记录即可。
51+
52+
上面的算法少考虑了一个问题,那就是如果 nums[i] > nums[i-2],我们其实可以选择 nums[i-1],转而和 dp[i-2] 产生联系。也就是 dp[i][1] = dp[i-2][0] + 1。这个 1 就是将 nums[i-1] 删掉的一个操作。
53+
54+
需要注意的是判断 nums[i] > nums[i-2] 不是在 nums[i] <= nums[i-1] 才需要考虑的。 比如 [1,2,3.0,4] 这种情况。当遍历到 4 的时候,虽然 4 > 0,但是我们不是和 dp[i-1] 结合,这样答案就小了,而是要和 nums[i-2] 结合。
55+
56+
扩展一下,如果题目限定了最多删除 k 个呢?
57+
58+
- 首先状态中列的长度要变成 k
59+
- 其次,我们往前比较的时候要比较 nums[i-1], nums[i-2], ... , nums[i-k-1],取这 k + 1 种情况的最大值。
60+
61+
## 关键点
62+
63+
- 连续性 DP
64+
65+
## 代码
66+
67+
代码支持:Python3
68+
69+
Python3 Code:
70+
71+
```py
72+
class Solution:
73+
def solve(self, nums):
74+
n = len(nums)
75+
if not n: return 0
76+
dp = [[1, 0] for _ in range(n)]
77+
ans = 1
78+
79+
for i in range(1,n):
80+
if nums[i] > nums[i-1]:
81+
dp[i][0] = dp[i-1][0] + 1
82+
dp[i][1] = dp[i-1][1] + 1
83+
else:
84+
dp[i][0] = 1
85+
dp[i][1] = 1
86+
if i > 1 and nums[i] > nums[i-2]:
87+
dp[i][1] = max(dp[i][1], 1 + dp[i-2][0])
88+
ans = max(ans, dp[i][0], dp[i][1])
89+
90+
return ans
91+
92+
```
93+
94+
**复杂度分析**
95+
96+
令 n 为数组长度。
97+
98+
- 时间复杂度:$O(n)$
99+
- 空间复杂度:$O(n)$
100+
101+
力扣的小伙伴可以[关注我](https://leetcode-cn.com/u/fe-lucifer/),这样就会第一时间收到我的动态啦~
102+
103+
以上就是本文的全部内容了。大家对此有何看法,欢迎给我留言,我有时间都会一一查看回答。更多算法套路可以访问我的 LeetCode 题解仓库:https://github.com/azl397985856/leetcode 。 目前已经 40K star 啦。大家也可以关注我的公众号《力扣加加》带你啃下算法这块硬骨头。

0 commit comments

Comments
 (0)